<?php
if ( ! class_exists( 'Museum_Artifact_Plugin_Activation_WPElemento_Importer' ) ) {
    /**
     * Museum_Artifact_Plugin_Activation_WPElemento_Importer initial setup
     *
     * @since 1.6.2
     */

    class Museum_Artifact_Plugin_Activation_WPElemento_Importer {

        private static $museum_artifact_instance;
        public $museum_artifact_action_count;
        public $museum_artifact_recommended_actions;

        /** Initiator **/
        public static function get_instance() {
          if ( ! isset( self::$museum_artifact_instance) ) {
            self::$museum_artifact_instance = new self();
          }
          return self::$museum_artifact_instance;
        }

        /*  Constructor */
        public function __construct() {

            add_action( 'admin_enqueue_scripts', array( $this, 'enqueue_scripts' ) );

            // ---------- wpelementoimpoter Plugin Activation -------
            add_filter( 'museum_artifact_recommended_plugins', array($this, 'museum_artifact_recommended_elemento_importer_plugins_array') );

            $museum_artifact_actions                   = $this->museum_artifact_get_recommended_actions();
            $this->museum_artifact_action_count        = $museum_artifact_actions['count'];
            $this->museum_artifact_recommended_actions = $museum_artifact_actions['actions'];

            add_action( 'wp_ajax_create_pattern_setup_builder', array( $this, 'create_pattern_setup_builder' ) );
        }

        public function museum_artifact_recommended_elemento_importer_plugins_array($museum_artifact_plugins){
            $museum_artifact_plugins[] = array(
                    'name'     => esc_html__('WPElemento Importer', 'museum-artifact'),
                    'slug'     =>  'wpelemento-importer',
                    'function' => 'WPElemento_Importer_ThemeWhizzie',
                    'desc'     => esc_html__('We highly recommend installing the WPElemento Importer plugin for importing the demo content with Elementor.', 'museum-artifact'),               
            );
            return $museum_artifact_plugins;
        }

        public function enqueue_scripts() {
            wp_enqueue_script('updates');      
            wp_register_script( 'museum-artifact-plugin-activation-script', esc_url(get_template_directory_uri()) . '/includes/getstart/js/plugin-activation.js', array('jquery') );
            wp_localize_script('museum-artifact-plugin-activation-script', 'museum_artifact_plugin_activate_plugin',
                array(
                    'installing' => esc_html__('Installing', 'museum-artifact'),
                    'activating' => esc_html__('Activating', 'museum-artifact'),
                    'error' => esc_html__('Error', 'museum-artifact'),
                    'ajax_url' => esc_url(admin_url('admin-ajax.php')),
                    'wpelementoimpoter_admin_url' => esc_url(admin_url('admin.php?page=wpelemento-importer-tgmpa-install-plugins')),
                    'addon_admin_url' => esc_url(admin_url('admin.php?page=wpelementoimporter-wizard'))
                )
            );
            wp_enqueue_script( 'museum-artifact-plugin-activation-script' );

        }

        // --------- Plugin Actions ---------
        public function museum_artifact_get_recommended_actions() {

            $museum_artifact_act_count  = 0;
            $museum_artifact_actions_todo = get_option( 'recommending_actions', array());

            $museum_artifact_plugins = $this->museum_artifact_get_recommended_plugins();

            if ($museum_artifact_plugins) {
                foreach ($museum_artifact_plugins as $museum_artifact_key => $museum_artifact_plugin) {
                    $museum_artifact_action = array();
                    if (!isset($museum_artifact_plugin['slug'])) {
                        continue;
                    }

                    $museum_artifact_action['id']   = 'install_' . $museum_artifact_plugin['slug'];
                    $museum_artifact_action['desc'] = '';
                    if (isset($museum_artifact_plugin['desc'])) {
                        $museum_artifact_action['desc'] = $museum_artifact_plugin['desc'];
                    }

                    $museum_artifact_action['name'] = '';
                    if (isset($museum_artifact_plugin['name'])) {
                        $museum_artifact_action['title'] = $museum_artifact_plugin['name'];
                    }

                    $museum_artifact_link_and_is_done  = $this->museum_artifact_get_plugin_buttion($museum_artifact_plugin['slug'], $museum_artifact_plugin['name'], $museum_artifact_plugin['function']);
                    $museum_artifact_action['link']    = $museum_artifact_link_and_is_done['button'];
                    $museum_artifact_action['is_done'] = $museum_artifact_link_and_is_done['done'];
                    if (!$museum_artifact_action['is_done'] && (!isset($museum_artifact_actions_todo[$museum_artifact_action['id']]) || !$museum_artifact_actions_todo[$museum_artifact_action['id']])) {
                        $museum_artifact_act_count++;
                    }
                    $museum_artifact_recommended_actions[] = $museum_artifact_action;
                    $museum_artifact_actions_todo[]        = array('id' => $museum_artifact_action['id'], 'watch' => true);
                }
                return array('count' => $museum_artifact_act_count, 'actions' => $museum_artifact_recommended_actions);
            }

        }

        public function museum_artifact_get_recommended_plugins() {

            $museum_artifact_plugins = apply_filters('museum_artifact_recommended_plugins', array());
            return $museum_artifact_plugins;
        }

        public function museum_artifact_get_plugin_buttion($slug, $name, $function) {
                $museum_artifact_is_done      = false;
                $museum_artifact_button_html  = '';
                $museum_artifact_is_installed = $this->is_plugin_installed($slug);
                $museum_artifact_plugin_path  = $this->get_plugin_basename_from_slug($slug);
                $museum_artifact_is_activeted = (class_exists($function)) ? true : false;
                if (!$museum_artifact_is_installed) {
                    $museum_artifact_plugin_install_url = add_query_arg(
                        array(
                            'action' => 'install-plugin',
                            'plugin' => $slug,
                        ),
                        self_admin_url('update.php')
                    );
                    $museum_artifact_plugin_install_url = wp_nonce_url($museum_artifact_plugin_install_url, 'install-plugin_' . esc_attr($slug));
                    $museum_artifact_button_html        = sprintf('<a class="museum-artifact-plugin-install install-now button-secondary button" data-slug="%1$s" href="%2$s" aria-label="%3$s" data-name="%4$s">%5$s</a>',
                        esc_attr($slug),
                        esc_url($museum_artifact_plugin_install_url),
                        sprintf(esc_html__('Install %s Now', 'museum-artifact'), esc_html($name)),
                        esc_html($name),
                        esc_html__('Install & Activate', 'museum-artifact')
                    );
                } elseif ($museum_artifact_is_installed && !$museum_artifact_is_activeted) {

                    $museum_artifact_plugin_activate_link = add_query_arg(
                        array(
                            'action'        => 'activate',
                            'plugin'        => rawurlencode($museum_artifact_plugin_path),
                            'plugin_status' => 'all',
                            'paged'         => '1',
                            '_wpnonce'      => wp_create_nonce('activate-plugin_' . $museum_artifact_plugin_path),
                        ), self_admin_url('plugins.php')
                    );

                    $museum_artifact_button_html = sprintf('<a class="museum-artifact-plugin-activate activate-now button-primary button" data-slug="%1$s" href="%2$s" aria-label="%3$s" data-name="%4$s">%5$s</a>',
                        esc_attr($slug),
                        esc_url($museum_artifact_plugin_activate_link),
                        sprintf(esc_html__('Activate %s Now', 'museum-artifact'), esc_html($name)),
                        esc_html($name),
                        esc_html__('Activate', 'museum-artifact')
                    );
                } elseif ($museum_artifact_is_activeted) {
                    $museum_artifact_button_html = sprintf('<div class="action-link button disabled"><span class="dashicons dashicons-yes"></span> %s</div>', esc_html__('Active', 'museum-artifact'));
                    $museum_artifact_is_done     = true;
                }

                return array('done' => $museum_artifact_is_done, 'button' => $museum_artifact_button_html);
            }
        public function is_plugin_installed($slug) {
            $museum_artifact_installed_plugins = $this->get_installed_plugins(); // Retrieve a list of all installed plugins (WP cached).
            $museum_artifact_file_path         = $this->get_plugin_basename_from_slug($slug);
            return (!empty($museum_artifact_installed_plugins[$museum_artifact_file_path]));
        }
        public function get_plugin_basename_from_slug($slug) {
            $museum_artifact_keys = array_keys($this->get_installed_plugins());
            foreach ($museum_artifact_keys as $museum_artifact_key) {
                if (preg_match('|^' . $slug . '/|', $museum_artifact_key)) {
                    return $museum_artifact_key;
                }
            }
            return $slug;
        }

        public function get_installed_plugins() {

            if (!function_exists('get_plugins')) {
                require_once ABSPATH . 'wp-admin/includes/plugin.php';
            }

            return get_plugins();
        }
        public function create_pattern_setup_builder() {

            $edit_page = admin_url().'post-new.php?post_type=page&create_pattern=true';
            echo json_encode(['page_id'=>'','edit_page_url'=> $edit_page ]);

            exit;
        }

    }
}
/**
 * Kicking this off by calling 'get_instance()' method
 */
Museum_Artifact_Plugin_Activation_WPElemento_Importer::get_instance();